crunch2BAM<-function(sam.files, dir=".")
# This crunches a set of SAM files to sorted & indexed BAM files using the samtools command. 
# We avoid calling Rsamtools because of strange errors with 'invalid cross-device link'. I 
# think it's putting things in /tmp when that might be full, and I can't see any option to 
# change the temporary directory. 
#
# written by Aaron Lun
{
	out<-NULL
    for (sam.file in sam.files) {
        prefix<-file.path(dir, sub("\\.sam$", "", basename(sam.file)))
        temp<-tempfile(tmpdir=dir)
	suppressWarnings(asBam(sam.file, temp, overwrite=TRUE, indexDestination=FALSE))
	temp <- paste0(temp, ".bam")
	suppressWarnings(sortBam(temp, prefix))
	bam.file<-paste0(prefix, ".bam")
        indexBam(bam.file)
        unlink(temp)
		out<-append(out, bam.file)
    }
    return(out);
}
