normalizeBackground <- function(x, lib.sizes=colSums(x), prop=0.75, ref=1L) 
# This performs background-based normalization, based on the row sums
# between each pair of libraries. It's basically the same as the
# implementation in the NCIS method, except that there's no optimization
# for 'prop' (or for the bin.size, based on what is given in 'x').
{
	nlib <- ncol(x)
	nr <- nrow(x)
	bg.out <- rep(1, nlib)

	for (fn in 1:nlib) {
		if (fn==ref) { next }
		rwsms <- x[,fn]+x[,ref]
		keep <- rank(rwsms, ties.method="random")/nr <= prop
		bg.out[fn] <- sum(x[keep,fn])/sum(x[keep,ref]) * lib.sizes[ref]/lib.sizes[fn]
	}
	bg.out <- bg.out/exp(mean(log(bg.out)))
	bg.out
}
